/*------------------------------------*\
    #OBJECTS.GRIDBLOCK
\*------------------------------------*/
/**
 * Grid block object. A grid block is a grid container (row) for sub-blocks (columns).
 * Its children must be of .o-gridblock__item.
 * The gridblock__item itself contains the actual content,
 * which can be objects or components.
 */
@import '../1-utils/utils.loader';
@import '../0-settings/settings.objects';

$inuit-gridblock-item-colspan-small-up: 24;

$inuit-gridblock-item-offset-1-small-up: 2;
$inuit-gridblock-item-offset-2-small-up: $inuit-gridblock-item-offset-1-small-up;

$inuit-gridblock-item-colspan-medium-up: 12;
$inuit-gridblock-item-offset-1-medium-up: 1;
$inuit-gridblock-item-offset-2-medium-up: 2;

$inuit-gridblock-item-colspan-large-up: 12;
$inuit-gridblock-item-full-colspan-large-up: $inuit-gridblock-item-colspan-small-up;
$inuit-gridblock-item-offset-1-large-up: $inuit-gridblock-item-offset-1-small-up;
$inuit-gridblock-item-offset-2-large-up: $inuit-gridblock-item-offset-1-small-up;
$blockgrid-spacing: 20px;

.#{$inuit-namespace}gridblock,
%#{$inuit-namespace}gridblock {
    @include grid-row(12);

    &--4columns {
        @include block-grid(
                $per-row: 1,
                    // This controls how much space is between each item in the block grid.
                    // Use a variable or any pixel or em values.
                $spacing: $blockgrid-spacing,
                $include-spacing: false
        );
        padding: 0;

        @media #{$small-up} {
            @include block-grid(
                    $per-row: 1,
                    $include-spacing: false
            );
            padding: 0;
        }

        @media #{$medium-up} {
            @include block-grid(
                    $per-row: 2,
                    $include-spacing: false
            );
            padding: 0;
        }

        @media #{$xlarge-up} {
            @include block-grid(
                    $per-row: 4,
                    $include-spacing: false
            );
            padding: 0;
        }

        @media #{$print} {
            @include block-grid(
                    $per-row: 4,
                    $include-spacing: false
            );
            padding: 0;
        }
    }

    &--3columns {
        @include block-grid(
            $per-row: 1,
            // This controls how much space is between each item in the block grid.
            // Use a variable or any pixel or em values.
            $spacing: $blockgrid-spacing,
            $include-spacing: false
        );
        padding: 0;

        @media #{$small-up} {
            @include block-grid(
                    $per-row: 1,
                    $include-spacing: false
            );
            padding: 0;
        }

        @media #{$medium-up} {
            @include block-grid(
                $per-row: 3,
                $include-spacing: false
            );
            padding: 0;
        }

        @media #{$xlarge-up} {
            @include block-grid(
                $per-row: 3,
                $include-spacing: false
            );
            padding: 0;
        }

        @media #{$print} {
            @include block-grid(
                $per-row: 3,
                $include-spacing: false
            );
            padding: 0;
        }
    }

    &--2columns {
        @include block-grid(
            $per-row: 1,
            // This controls how much space is between each item in the block grid.
            // Use a variable or any pixel or em values.
            $spacing: $blockgrid-spacing
        );
        padding: 0;

        @media #{$small-up} {
            @include block-grid(
                $per-row: 1,
                $include-spacing: false
            );
            padding: 0;
        }

        @media #{$medium-up} {
            @include block-grid(
                $per-row: 2,
                $include-spacing: false
            );
            padding: 0;
        }

        @media #{$large-up} {
            @include block-grid(
                $per-row: 2,
                $include-spacing: false
            );
            padding: 0;
        }

        @media #{$print} {
            @include block-grid(
                $per-row: 2,
                $include-spacing: false
            );
            padding: 0;
        }
    }

    &--1column {
        @include block-grid(
            $per-row: 1,
            $include-spacing: false
        );

        //padding-bottom: $blockgrid-spacing;
        ////margin-bottom: 35px;

        @media #{$medium-up} {
            @include block-grid(
                $per-row: 1,
                $include-spacing: false
            );
        }

        @media #{$large-up} {
            @include block-grid(
                $per-row: 1,
                $include-spacing: false
            );
        }

        @media #{$print} {
            @include block-grid(
                $per-row: 1,
                $include-spacing: false
            );
        }
    }
}

/*
Override for displaying columns correctly inside
gridlements container
*/

.#{$inuit-namespace}gridblock__item,
%#{$inuit-namespace}gridblock__item {
    //margin-bottom: $inuit-base-space-vertical-small-only;

    &:last-of-type {
        //margin-bottom: $blockgrid-spacing;
    }

    @media #{$small-only} {
        @include grid-column(
            $columns: $inuit-gridblock-item-colspan-small-up
        );

        padding: 0;
    }

    @media #{$medium-only} {
        @include grid-column(
            $columns: $inuit-gridblock-item-colspan-medium-up
        );

        padding-left: 0;

        &:nth-of-type(2n) {
            @include grid-column(
                $columns: $inuit-gridblock-item-colspan-medium-up
            );

            padding-right: 0;
        }

        // Remove bottom margin from all items in the last row
        &:nth-last-of-type(-n+2) {
            //margin-bottom: 0;
        }
    }

    @media #{$medium-up} {
        //margin-bottom: drk-halve($drk-grid-unit);

        &:nth-of-type(2n+1) {
            clear: left;
        }
    }

    @media #{$large-up} {
        @include grid-column(
            $columns: $inuit-gridblock-item-colspan-large-up
        );
        padding-left: 0;

        &:nth-of-type(2n) {
            @include grid-column(
                $columns: 12
            );
            padding-right: 0;
        }
    }

    &--map {
        width: 100%;
        float: none;

        @media #{$medium-up} {
            width: 60%;
            padding-right: 30px;
            float: left;
        }
    }

    &--list {
        width: 100%;
        float: none;

        @media #{$medium-up} {
            width: 40%;
            float: left;
        }
    }

    // Smaller teasers that allow for 3 of them in a row on large devices.
    // Falls back to the default gridblock defined above on smaller screens.
    &--small {
        @media #{$large-up} {
            @include grid-column(
                $columns: 8
            );

            &:nth-of-type(2n) {
                @include grid-column(
                    $columns: 8
                );

            }

            &:nth-of-type(2n+1) {
                clear: none;
            }

            // Every first item in a row gets offset a bit more
            &:nth-of-type(3n+1) {
                @include grid-column(
                    $columns: 8
                );
            }

            // Remove bottom margin from all items in the last row
            &:nth-last-of-type(-n+3) {
                //margin-bottom: 0;
            }
        }
    }

    // Larger teasers that allow for a 33/66 column layout.
    // Falls back to the default gridblock defined above on smaller screens.
    &--large {
        @media #{$large-up} {
            @include grid-column(
                $columns: 16
            );
            padding-left: 0;

            ~ .o-gridblock__item--small {
                padding-right: 0;
            }

            &:nth-of-type(2n) {
                @include grid-column(
                    $columns: 16
                );
            }

            // Every first item in a row gets offset a bit more
            &:nth-of-type(2n+1) {
                clear: left;
            }
        }
    }

    /**
     * Gridblock item spanning full width
     */
    &--full {

        &,
        &:nth-of-type(2n) {
            @include grid-column(
                $columns: $inuit-gridblock-item-colspan-small-up
            );

            //@include drk-grid-offset($inuit-gridblock-item-offset-1-small-up);
            padding: 0;

            @media #{$medium-up} {
                @include grid-column(
                    $columns: 22
                );

                padding: 0;
            }

            @media #{$large-up} {
                @include grid-column(
                    $columns: 24
                );

                padding: 0;
            }
        }
    }

    /**
     * o-gridblock__item--centered is half-width (6 cols) and will be centered on the page.
     * Its content itself will not be centered. If you need it to be you may apply h-text-center.
     */

    &--centered {
        @media #{$medium-up} {
            @include grid-column(
                $columns: 18,
                $collapse: true
            );

            @include drk-grid-offset(3);
        }
    }

    /**
     * o-gridblock__item--pushed will be a 6-col width block that's been pushed to the
     * right side of the page. It will look like there was an empty left column.
     */

    &--pushed {
        @media #{$medium-up} {
            @include grid-column(
                $columns: 12,
                $collapse: false
            );

            @include drk-grid-offset(12);
        }
    }

    /**
     * this rules are necessary to display columns and embedded elements
     * with correct paddings and margins
     */
    .o-gridblock__item {
        &,
        &--full {
            margin-left: 0;
            width: 100%;
        }
    }

    .c-divider {
        width: 100% !important;
    }
}
